@extends('layouts.main')

@section('content')
<main class="content">
    <div class="g-color"></div>
    <div class="table-header position-relative">
        <div class="row justify-content-between">
            <form class="hd-date-input mt-5" action="{{ route('detailedreportview') }}" method="post">
                @csrf
                <div class="col-md-12">
                    <ul class="d-flex align-items-center p-0">
                        <input type="hidden" name="sval" value="1" />
                        <li class="">
                            <div class="date-input d-flex align-items-center position-relative"><b class="me-3">Date
                                    From:</b>
                                    <span class="date-inputbox position-relative w-50">
                                <input class="form-control" type="text" name="fromdate"
                                    value="<?php echo date('d-m-Y', strtotime($from_date)); ?>" id="from_date_input"
                                    autocomplete="off">
                                <i class="ri-calendar-2-line"></i>
                            </span>
                            </div>
                        </li>
                        <li class="">
                            <div class=" date-input d-flex align-items-center position-relative"><b class="me-2">To
                                    :</b>
                                     <span class="date-inputbox position-relative w-75">
                                <input class="form-control" type="text" name="todate"
                                    value="<?php echo date('d-m-Y', strtotime($to_date)); ?>" id="to_date_input"
                                    autocomplete="off">
                                <i class="ri-calendar-2-line"></i>
                            </span>
                            </div>
                        </li>
                        <li class="">

                            <div class="d-flex align-items-center position-relative">
                                <b class="me-2">Tank List :</b>
                                <select class="form-select w-50 me-2" name="tank_list" id="tank_list"
                                    aria-label="Default select example">
                                    @foreach ($all_tanks as $tank)
                                    <option value="{{ $tank->id }}" @if($tank->id==$tank_uid){{'selected'}}@endif>
                                        {{ $tank->tank_name }}
                                    </option>
                                    @endforeach
                                </select>

                            </div>
                        </li>
                        <li class="">

                            <div class="d-flex align-items-center position-relative"><b class="me-2">Parameter Type
                                    :</b>
                                <select class="form-select w-75 me-2" name="device_type_id" id="device_type_id"
                                    aria-label="Default select example">
                                    <option value="chlrn" <?php if($param_val == 'chlrn'){ ?> selected="selected"
                                        <?php } ?>>CL </option>
                                    <option value="ph" <?php if($param_val == 'ph'){ ?> selected="selected" <?php } ?>>
                                        PH </option>
                                    <option value="iron_lvl" <?php if($param_val == 'iron_lvl'){ ?> selected="selected"
                                        <?php } ?>>IRON </option>
                                    <option value="tds" <?php if($param_val == 'tds'){ ?> selected="selected"
                                        <?php } ?>>TDS </option>
                                    <option value="tur" <?php if($param_val == 'tur'){ ?> selected="selected"
                                        <?php } ?>>Turbidity </option>
                                    <option value="temp" <?php if($param_val == 'temp'){ ?> selected="selected"
                                        <?php } ?>>Temperature </option>
                                    <option value="water_lvl" <?php if($param_val == 'water_lvl'){ ?>
                                        selected="selected" <?php } ?>>Water </option>
                                </select>
                                <button type="submit" class="btn btn-primary"
                                    onClick="return validation();">Submit</button>
                            </div>
                        </li>
                    </ul>
                </div>
            </form>
        </div>
    </div>
    <div class="position-relative">
        <div class="container-sec">
            <div class="cotainer-body p-4">
                <div class="page-hading">
                    <div class="d-flex align-items-center position-relative d-sm-block d-md-flex">
                        <a href="#" class="d-flex align-items-center me-4 mb-0">
                            <i class="ri-table-line"></i>Tank wise detailed report Chart
                        </a>
                        <div class="detasheet-graph-icon ms-auto">
                            <a href="javascript:history.back()">Datasheet</a>
                            <a href="#" class="active">Graph</a>
                        </div>
                        <form method="get" class="download-btn-sec  mb-0" action="{{ route('detailedreportexcel', $encdata)}}">
                            <button class="btn download-btn ms-2"><i class="ri-folder-download-fill"></i>
                                Download</button>
                        </form>
                    </div>
                </div>
                <div class="row row-spacing">
                    <div class="col-md-12">&nbsp;</div>
                </div>
                <?php // echo "<pre>"; print_r($readings); die;  ?>
                <?php
				// Prepare data for Highcharts
				$dates = [];
				$parvals = [];
				
				foreach ($readings as $reading) {
					$dates[] = $reading->created_at_display;
					$parvals[] = $reading->parval;
				}				
				?>

                <div class="add-tank">
                    <div class="row">
                        <div class="col-md-12">
                            <div id="container"></div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>


</main>

@endsection
@push('scripts')
<link rel="stylesheet" href="https://code.jquery.com/ui/1.13.2/themes/base/jquery-ui.css">
<script src="https://code.jquery.com/ui/1.13.2/jquery-ui.min.js"></script>
<script>
$(function() {
    // Initialize datepickers with format dd-mm-yy
    $('#from_date_input, #to_date_input').datepicker({
        dateFormat: 'dd-mm-yy'
    });

    // Event handler for fromdate selection
    $('#device_purchased_on').on('change', function() {
        var fromDate = $(this).datepicker('getDate');

        // Set maxDate on todate (fromDate + 7 days)
        if (fromDate) {
            var maxDate = new Date(fromDate);
            maxDate.setDate(maxDate.getDate() + 29);

            $('#device_purchased_on').datepicker('option', 'minDate', fromDate);
            $('#device_purchased_on1').datepicker('option', 'maxDate', maxDate);
        }
    });

    // Event handler for todate selection
    $('#device_purchased_on1').on('change', function() {
        var fromDate = $('#fromdate').datepicker('getDate');
        var toDate = $(this).datepicker('getDate');

        if (fromDate && toDate) {
            var diffDays = (toDate - fromDate) / (1000 * 60 * 60 * 24); // Difference in days

            if (diffDays > 29) {
                alert('The date range cannot exceed 15 days.');
                $(this).val(''); // Reset todate value
            }
        }
    });
});
</script>
@endpush

<script src="https://code.highcharts.com/highcharts.js"></script>
<script type="text/javascript">
document.addEventListener('DOMContentLoaded', function() {
	// Set locale options
    Highcharts.setOptions({
        lang: {
            decimalPoint: '.',
            thousandsSep: ','
        }
    });

    // Prepare the data passed from the controller
    var dates = @json($dates);
    var parvals = @json($parvals);

    // Initialize Highcharts
    Highcharts.chart('container', {
        chart: {
            type: 'column' // for bar chart, you can use 'column' or 'bar'
        },
        title: {
            text: 'Parameter Values Over Time'
        },
        xAxis: {
            categories: dates, // Dates on the x-axis
            title: {
                text: 'Date'
            }
        },
        yAxis: {
            title: {
                text: 'Parameter Value (parval)' // Y-axis title
            }
        },
        series: [{
            name: '{{ $paramName }}',
            data: parvals // Parameter values on the y-axis
        }]
    });
});
</script>