@extends('layouts.main')

@section('content')
<main class="content">
    <div class="g-color"></div>
    <div class="table-header position-relative">

        <div class="row justify-content-between">
            <form class="hd-date-input mt-5" action="{{ route('detailedreportview') }}" method="post">
                @csrf
                <div class="col-md-12">
                    <ul class="d-flex align-items-center p-0">
                        <input type="hidden" name="sval" value="1" />
                        <li class="">
                            <div class="date-input d-flex align-items-center position-relative"><b class="me-3">Date
                                    From:</b>
                                <span class="date-inputbox position-relative w-50">
                                    <input class="form-control " type="text" name="fromdate"
                                        value="<?php echo date('d-m-Y', strtotime($from_date)); ?>" id="from_date_input"
                                        autocomplete="off">
                                    <i class="ri-calendar-2-line"></i>
                                </span>
                            </div>
                        </li>
                        <li class="">
                            <div class=" date-input d-flex align-items-center position-relative"><b class="me-2">To
                                    :</b>
                                <span class="date-inputbox position-relative w-75">
                                    <input class="form-control " type="text" name="todate"
                                        value="<?php echo date('d-m-Y', strtotime($to_date)); ?>" id="to_date_input"
                                        autocomplete="off">
                                    <i class="ri-calendar-2-line"></i>
                                </span>
                            </div>
                        </li>
                        <li class="">
                            <div class="d-flex align-items-center position-relative">
                                <b class="me-2">Tank List :</b>

                                <select class="form-select w-50 me-2" name="tank_list" id="tank_list"
                                    aria-label="Default select example">
                                    @foreach ($all_tanks as $tank)
                                    <?php $tname = strtolower(str_replace(' ', '', $tank->tank_name)); ?>
                                    <option value="{{ $tank->id }}" @if($tank->id==$tank_uid){{'selected'}}@endif
                                        >{{ $tank->tank_name }}</option>
                                    @endforeach
                                </select>

                            </div>
                        </li>
                        <li class="">
                            <div class="d-flex align-items-center position-relative"><b class="me-2 w-75">Parameter Type
                                    :</b>

                                <select class="form-select  me-2" name="device_type_id" id="device_type_id"
                                    aria-label="Default select example">
                                    <option value="chlrn" <?php if ($param_val == 'chlrn') { ?> selected="selected"
                                        <?php } ?>>CL </option>
                                    <option value="ph" <?php if ($param_val == 'ph') { ?> selected="selected"
                                        <?php } ?>>PH </option>
                                    <option value="iron_lvl" <?php if ($param_val == 'iron_lvl') { ?>
                                        selected="selected" <?php } ?>>IRON </option>
                                    <option value="tds" <?php if ($param_val == 'tds') { ?> selected="selected"
                                        <?php } ?>>TDS </option>
                                    <option value="tur" <?php if ($param_val == 'tur') { ?> selected="selected"
                                        <?php } ?>>Turbidity </option>
                                    <option value="temp" <?php if ($param_val == 'temp') { ?> selected="selected"
                                        <?php } ?>>Temperature </option>
                                    <option value="water_lvl" <?php if ($param_val == 'water_lvl') { ?>
                                        selected="selected" <?php } ?>>Water </option>
                                </select>

                                <button type="submit" class="btn btn-primary"
                                    onClick="return validation();">Submit</button>
                            </div>
                        </li>
                    </ul>
                </div>

            </form>
        </div>
    </div>
    <div class="position-relative">
        <div class="container-sec">
            <div class="cotainer-body p-4">
                <div class="page-hading">
                    <div class="d-flex align-items-center position-relative d-sm-block d-md-flex">
                        <a href="#" class="d-flex align-items-center me-4 mb-0">
                            <i class="ri-table-line"></i><span>Tank wise detailed report</span>
                        </a>
                        <div class="detasheet-graph-icon ms-auto">
                            <a href="#" class="active">Datasheet</a>
                            <a href="{{route('detailedreportchart',$enc_data)}}" class="">Graph</a>
                        </div>
                        <form method="get" class="download-btn-sec mb-0"
                            action="{{ route('detailedreportexcel',$enc_data) }}">
                            <button class="btn download-btn ms-2"><i class="ri-folder-download-fill"></i>
                                Download</button>
                        </form>
                    </div>
                </div>

                <div class="tank-wise-sec">
                    <h2 class="mt-3 mb-3 align-items-center d-flex"><i class="ri-calendar-2-line me-2"
                            style="font-size: 24px; font-weight: 100;"></i> From:
                        {{ date('d-m-Y', strtotime($from_date)) }} To: {{ date('d-m-Y', strtotime($to_date)) }}
                    </h2>
                    <?php // echo "<pre>"; print_r($data); 
                    ?>
                    <!-- water level table -->
                    <div class="row">
                        <h2 class="mt-3 mb-3 align-items-center d-flex"><i class="ri-table-2 me-2"
                                style="font-size: 24px; font-weight: 100;"></i> Parameter : {{ $paramName }}
                        </h2>
                        <div class="table-ar">
                            <table class="table table-striped table-bordered">
                                <thead>
                                    <tr>
                                        <th scope="col" style="text-align: left;">Date </th>
                                        <th scope="col">Value (<?php if(!empty($unit)){ echo $unit; } ?>) </th>
                                        <!--<th scope="col">Unit</th>-->
                                    </tr>
                                </thead>
                                <tbody>

                                    @foreach ($data as $row)
                                    <?php if(!empty($row)){ ?>
                                    <tr>
                                        <td style="text-align: left;">
                                            <?php if($row->parval > $water_measures->param_max_value || $row->parval < $water_measures->param_min_value){ ?><span
                                                style="color:#FF0000;"><?php }else{ ?><span><?php } ?>{{$row->created_at_display}}</span>
                                        </td>
                                        <td><?php if($row->parval > $water_measures->param_max_value || $row->parval < $water_measures->param_min_value){ ?><span
                                                style="color:#FF0000;"><?php }else{ ?><span><?php } ?>{!!
                                                    number_format((float)($row->parval), 2) !!}</span> </td>
                                        <!--<td>Ft</td>-->
                                    </tr>
                                    <?php }else{ ?>
                                    <tr>
                                        <td colspan="2" style="text-align: left;">No Record Found</td>
                                        <!--<td>Ft</td>-->
                                    </tr>
                                    <?php } ?>
                                    @endforeach

                                </tbody>
                            </table>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>

    <!-- <footer class="footer">
          <small style="margin-bottom: 20px; display: inline-block">
            © 2022 made with
            <span style="color: red; font-size: 18px">&#10084;</span> by -
            <a target="_blank" href="#"> Mohamed Azouaoui </a>
          </small>
          <br />
          <div>
            <a href="#" target="_blank" rel="noopener noreferrer">
              <img alt="GitHub followers" src="#" />
            </a>
            <a href="#" target="_blank" rel="noopener noreferrer">
              <img alt="Twitter Follow" src="#" />
            </a>
          </div>
        </footer> -->
</main>
@endsection
@push('scripts')
<link rel="stylesheet" href="https://code.jquery.com/ui/1.13.2/themes/base/jquery-ui.css">
<script src="https://code.jquery.com/ui/1.13.2/jquery-ui.min.js"></script>
<script>
$(function() {
    // Initialize datepickers with format dd-mm-yy
    $('#from_date_input, #to_date_input').datepicker({
        dateFormat: 'dd-mm-yy'
    });

    // Event handler for fromdate selection
    $('#device_purchased_on').on('change', function() {
        var fromDate = $(this).datepicker('getDate');

        // Set maxDate on todate (fromDate + 7 days)
        if (fromDate) {
            var maxDate = new Date(fromDate);
            maxDate.setDate(maxDate.getDate() + 29);

            $('#device_purchased_on').datepicker('option', 'minDate', fromDate);
            $('#device_purchased_on1').datepicker('option', 'maxDate', maxDate);
        }
    });

    // Event handler for todate selection
    $('#device_purchased_on1').on('change', function() {
        var fromDate = $('#fromdate').datepicker('getDate');
        var toDate = $(this).datepicker('getDate');

        if (fromDate && toDate) {
            var diffDays = (toDate - fromDate) / (1000 * 60 * 60 * 24); // Difference in days

            if (diffDays > 29) {
                alert('The date range cannot exceed 15 days.');
                $(this).val(''); // Reset todate value
            }
        }
    });
});
</script>
@endpush

</body>

</html>