@extends('layouts.main')

@section('content')
<main class="content">
        <div class="g-color"></div>
		<div class="table-header position-relative">
        <div class="row justify-content-between ">
		</div>
        <div class="row justify-content-between">
						<form class="mt-5" action="{{ route('phmonitorchart') }}" method="post">
						@csrf
							<div class="col-md-12">
							  <ul class="d-flex align-items-center p-0">
								<li class="">
								  <div class="d-flex align-items-center position-relative"><b class="me-3">Date Range:</b>
									<input class="form-control w-50" value="<?php if($fdate == ""){ echo ""; }else{ echo date('d-m-Y',strtotime($fdate)); } ?>" name="fromdate" id="device_purchased_on" type="text" autocomplete="off">
								  </div>
								</li>
								<li class="">
								  <div class="d-flex align-items-center position-relative"><b class="me-2">To :</b>
									<input class="form-control w-75" type="text" value="<?php if($fdate == ""){ echo ""; }else{ echo date('d-m-Y',strtotime($tdate)); } ?>" id="device_purchased_on1" name="todate" autocomplete="off">
								  </div>
								  <input type="hidden" name="sval" value="1" />
								</li>
								
								<li class="">
								  <div class="btn-sec m-2">
									<button type="submit" class="btn btn-primary" onClick="return validation();">Submit</button>
								  </div>
								</li>
							  </ul>
							</div>
						</form>								
						</div>
    </div>
        <div class="position-relative">
          <div class="container-sec">
            <div class="cotainer-body p-4">
              <div class="page-hading">
                    <div class="d-flex align-items-center justify-content-between">
                        <h2>PH Level Monitor Report</h2>
                    </div>
                </div>
				<div class="row row-spacing">
				  <div class="col-md-12">&nbsp;</div>	
				</div>
<?php // echo "<pre>"; print_r($measures);  die; ?>
			  <div class="add-tank">
			  @foreach($data as $tank_id => $tank_data)
					<div class="row">					
						@php
							$tankName = $tank_data['tank_name']; 
							$tankResults = $tank_data['result'];
							// Prepare data for Highcharts
							$times = [];
							$phValues = [];					
						
							foreach ($tankResults as $result) {
								$times[] = $result->created_at;  // x-axis (time)
								$phValues[] = (float) $result->ph;  // y-axis (ph value)
							}
						@endphp
						
						<div class="col-md-12">
							<div id="container-{{ $tank_id }}" style="width: 100%; height: 500px;">
								@if(empty($tankResults))
									<p>There is no record available</p>
								@else
									<script>
										Highcharts.chart('container-{{ $tank_id }}', {
											chart: {
												type: 'column'  // Bar chart (vertical columns)
											},
											title: {
												text: '{{ $tankName }} ph Values Over Time'
											},
											xAxis: {
												categories: {!! json_encode($times) !!},  // Time data for x-axis
												title: {
													text: 'Time'
												}
											},
											yAxis: {
												title: {
													text: 'ph Value'
												},
												plotLines: [{
													value: {{ $measures->param_min_value }},
													color: 'red',
													width: 2,
													dashStyle: 'Dash',
													zIndex: 5,  // Ensures the line is drawn on top of bars
													label: {
														text: 'Min Threshold ({{ $measures->param_min_value }})',
														align: 'left',
														style: {
															color: 'orange'
														}
													}
												}, {
													value: {{ $measures->param_max_value }},
													color: 'green',
													width: 2,
													dashStyle: 'Dash',
													zIndex: 5,  // Ensures the line is drawn on top of bars
													label: {
														text: 'Max Threshold ({{ $measures->param_max_value }})',
														align: 'left',
														style: {
															color: 'red'
														}
													}
												}]
											},
											series: [{
												name: 'ph',
												data: {!! json_encode($phValues) !!},  // PH data for y-axis
												color: '#7cb5ec'  // Optional: Set a custom color for the bars
											}],
											tooltip: {
												valueSuffix: ' ph'
											}
										});
									</script>
								@endif
							</div>
						</div>
						
						<div class="row row-spacing">
							<div class="col-md-12">&nbsp;</div>	
						</div>
					</div>
				@endforeach          

              </div>			  
            </div>
          </div>
        </div>

        
      </main>

@endsection	 

<script src="https://code.highcharts.com/highcharts.js"></script>
<script src="https://code.highcharts.com/modules/accessibility.js"></script>



@push('scripts')
<link rel="stylesheet" href="https://code.jquery.com/ui/1.13.2/themes/base/jquery-ui.css">
<script src="https://code.jquery.com/ui/1.13.2/jquery-ui.min.js"></script>
<script>
        $(function() {
            // Initialize datepickers with format dd-mm-yy
            $('#device_purchased_on, #device_purchased_on1').datepicker({
                dateFormat: 'dd-mm-yy'
            });

            // Event handler for fromdate selection
            $('#device_purchased_on').on('change', function() {
                var fromDate = $(this).datepicker('getDate');

                // Set maxDate on todate (fromDate + 7 days)
                if (fromDate) {
                    var maxDate = new Date(fromDate);
                    maxDate.setDate(maxDate.getDate() + 6);

                    $('#device_purchased_on').datepicker('option', 'minDate', fromDate);
                    $('#device_purchased_on1').datepicker('option', 'maxDate', maxDate);
                }
            });

            // Event handler for todate selection
            $('#device_purchased_on1').on('change', function() {
                var fromDate = $('#fromdate').datepicker('getDate');
                var toDate = $(this).datepicker('getDate');

                if (fromDate && toDate) {
                    var diffDays = (toDate - fromDate) / (1000 * 60 * 60 * 24); // Difference in days

                    if (diffDays > 6) {
                        alert('The date range cannot exceed 15 days.');
                        $(this).val(''); // Reset todate value
                    }
                }
            });
        });
    </script>
@endpush

<script>
  function validation() {
    if (document.getElementById('device_purchased_on').value == "") {
      $('#error-fdt').html('* From Date Is Required');
      $('#error-fdt').css('color', 'red');
      $('#device_purchased_on').focus();
      return false;
    }
    if (document.getElementById('device_purchased_on1').value == "") {
      $('#error-tdt').html('* To Date Is Required');
      $('#error-tdt').css('color', 'red');
      $('#device_purchased_on1').focus();
      return false;
    }
    
    if (document.getElementById('tank_list').value == "") {
      $('#error-tl').html('* Select A Tank');
      $('#error-tl').css('color', 'red');
      $('#tank_list').focus();
        return false;
    }
    
    return true;
  }
</script>
