@extends('layouts.main')

@section('content')
<main class="content">
    <div class="g-color"></div>
	<div class="table-header position-relative">
        <div class="row justify-content-between">
            <form class="hd-date-input mt-5" action="{{ route('tankDateReport') }}" method="post">
                @csrf
                <div class="col-md-12">
                    <ul class="d-flex align-items-center p-0">
                        
						<li class="">
                            <div class="date-input d-flex align-items-center position-relative"><b class="me-3">Date From:</b>
                                   <span class="date-inputbox position-relative w-50">

                                <input class="form-control" type="text" name="fromdate" value="<?php echo date('d-m-Y', strtotime($from_date)); ?>" id="from_date_input" autocomplete="off">
								<i class="ri-calendar-2-line"></i>
                            </span>
                            </div>
                        </li>
                        <li class="">
                            <div class=" date-input d-flex align-items-center position-relative"><b class="me-2">To :</b>
                                 <span class="date-inputbox position-relative w-75">
                                <input class="form-control " type="text" name="todate" value="<?php echo date('d-m-Y', strtotime($to_date)); ?>" id="to_date_input" autocomplete="off">
								<i class="ri-calendar-2-line"></i>
                            </span>
                            </div>
                        </li>
                        <li class="">
                            <div class="d-flex align-items-center position-relative"><b class="me-2">Search By :</b>
                                <select class="form-select w-50" name="view_by" id="view_by"
                                    aria-label="Default select example">
                                    <!--<option value="">Select View Type</option>-->
                                    <option value="1" @if($view_by==1) {{'selected'}} @endif>Tank Wise</option>
                                    <option value="2" @if($view_by==2) {{'selected'}} @endif>KPI Wise</option>
                                </select>
                            </div>
                        </li>
                         <li class="" id="tank_wise" @if($view_by==2) style="display: none;" @endif>
							
                            <div class="d-flex align-items-center position-relative">
							<b class="me-2 w-50">Tank List :</b>
                                <select class="form-select w-50 me-2" name="tank_list" id="tank_list"
                                    aria-label="Default select example">
                                    <!--<option value="">Select Tank</option>-->
                                    @foreach ($all_tanks as $tank)
                                    <option value="{{ $tank->id }}" @if($tank->id==$tank_uid){{'selected'}}@endif>
                                        {{ $tank->tank_name }}
                                    </option>
                                    @endforeach
                                </select>
                            <button type="submit" class="btn btn-primary"
                                    onClick="return validation();">Submit</button>
                            </div>
                        </li>
						<li class=""  id="KPI_wise" @if($view_by==1) style="display: none;" @endif>
						
						 <div class="d-flex align-items-center position-relative"><b class="me-2">Parameter Type :</b>
                                <select class="form-select w-75 me-2" name="device_type_id" id="device_type_id"
                                    aria-label="Default select example">
                                    <!--<option value="">Select Parameter Type</option>-->
                                    <option value="chlrn">CL </option>
                                    <option value="ph">PH </option>
                                    <option value="iron_lvl">IRON </option>
                                    <option value="tds">TDS </option>
                                    <option value="tur">Turbidity </option>
                                    <!-- <option value="6">Temperature Sensor</option>-->
                                    <option value="water_lvl">Water </option>
                                </select>
                            <button type="submit" class="btn btn-primary"
                                    onClick="return validation();">Submit</button>
							</div>
						</li>
                    </ul>
                </div>
            </form>
        </div>
    </div>
    <div class="position-relative">
        <div class="container-sec">
            <div class="cotainer-body p-4">
                <div class="page-hading">
                    <div class="d-flex align-items-center position-relative d-sm-block d-md-flex">
                        <a href="#" class="d-flex align-items-center me-4 mb-0">
                            <i class="ri-table-line"></i>Historical Data Chart
                        </a>
                        <div class="detasheet-graph-icon ms-auto">
                            <a href="javascript:history.back()" >Datasheet</a>
                            <a href="#" class="active">Graph</a>
                        </div>
                    </div>
                </div>
                <div class="row row-spacing">
                    <div class="col-md-12">&nbsp;</div>
                </div>
                <?php // echo "<pre>"; print_r($tdsValues); die; 
                ?>
                <div class="add-tank">
                    <div class="row">
                        <div class="col-md-6">
                            <div id="containerph"></div>
                        </div>
                        <div class="col-md-6">
                            <div id="containerOPR"></div>
                        </div>
                    </div>
                    <div class="row row-spacing">
                        <div class="col-md-12">&nbsp;</div>
                    </div>
                    <div class="row">
                        <div class="col-md-6">
                            <div id="containerchlrn"></div>
                        </div>
                        <div class="col-md-6">
                            <div id="containertds"></div>
                        </div>
                    </div>
                    <div class="row row-spacing">
                        <div class="col-md-12">&nbsp;</div>
                    </div>
                    <div class="row">
                        <div class="col-md-6">
                            <div id="containertur"></div>
                        </div>
                        <div class="col-md-6">
                            <div id="containerwater_lvl"></div>
                        </div>
                    </div>



                </div>
            </div>
        </div>
    </div>


</main>

@endsection
@push('scripts')
<link rel="stylesheet" href="https://code.jquery.com/ui/1.13.2/themes/base/jquery-ui.css">
<script src="https://code.jquery.com/ui/1.13.2/jquery-ui.min.js"></script>
<script>
        $(function() {
            // Initialize datepickers with format dd-mm-yy
            $('#from_date_input, #to_date_input').datepicker({
                dateFormat: 'dd-mm-yy'
            });

            // Event handler for fromdate selection
            $('#device_purchased_on').on('change', function() {
                var fromDate = $(this).datepicker('getDate');

                // Set maxDate on todate (fromDate + 7 days)
                if (fromDate) {
                    var maxDate = new Date(fromDate);
                    maxDate.setDate(maxDate.getDate() + 29);

                    $('#device_purchased_on').datepicker('option', 'minDate', fromDate);
                    $('#device_purchased_on1').datepicker('option', 'maxDate', maxDate);
                }
            });

            // Event handler for todate selection
            $('#device_purchased_on1').on('change', function() {
                var fromDate = $('#fromdate').datepicker('getDate');
                var toDate = $(this).datepicker('getDate');

                if (fromDate && toDate) {
                    var diffDays = (toDate - fromDate) / (1000 * 60 * 60 * 24); // Difference in days

                    if (diffDays > 29) {
                        alert('The date range cannot exceed 15 days.');
                        $(this).val(''); // Reset todate value
                    }
                }
            });
        });
</script>
@endpush
<script>
    document.addEventListener('DOMContentLoaded', function() {
        // Get the elements
        var viewBy = document.getElementById('view_by');
        var tankWiseDiv = document.getElementById('tank_wise');
        var KPIWiseDiv = document.getElementById('KPI_wise');

        // Add event listener to the select element
        viewBy.addEventListener('change', function() {
            var selectedValue = this.value;

            // Reset both divs to hidden initially
            tankWiseDiv.style.display = 'none';
            KPIWiseDiv.style.display = 'none';

            // Show the relevant div based on the selected option
            if (selectedValue === '1') {
                tankWiseDiv.style.display = 'block'; // Show Tank Wise div
            } else if (selectedValue === '2') {
                KPIWiseDiv.style.display = 'block'; // Show KPI Wise div
            }
        });
    });
</script>
<script>
    function validation() {
        if (document.getElementById('device_purchased_on').value == "") {
            $('#error-fdt').html('* From Date Is Required');
            $('#error-fdt').css('color', 'red');
            $('#device_purchased_on').focus();
            return false;
        }
        if (document.getElementById('device_purchased_on1').value == "") {
            $('#error-tdt').html('* To Date Is Required');
            $('#error-tdt').css('color', 'red');
            $('#device_purchased_on1').focus();
            return false;
        }
        if (document.getElementById('view_by').value == "") {
            $('#error-vb').html('* Select Search By');
            $('#error-vb').css('color', 'red');
            $('#view_by').focus();
            return false;
        }
        if (document.getElementById('view_by').value == "1") {
            if (document.getElementById('tank_list').value == "") {
                $('#error-tl').html('* Select A Tank');
                $('#error-tl').css('color', 'red');
                $('#tank_list').focus();
                return false;
            }
        }
        if (document.getElementById('view_by').value == "2") {
            if (document.getElementById('device_type_id').value == "") {
                $('#error-dti').html('* Select A Parameter');
                $('#error-dti').css('color', 'red');
                $('#device_type_id').focus();
                return false;
            }
        }
        return true;
    }
</script>
<script src="https://code.highcharts.com/highcharts.js"></script>
<script>
    document.addEventListener('DOMContentLoaded', function() {
			// Set locale options
		Highcharts.setOptions({
			lang: {
				decimalPoint: '.',
				thousandsSep: ','
			}
		});

        // Prepare the data for xAxis (dates) and yAxis (ph values)
        let dates = [];
        let maxPhValues = [];
        let minPhValues = [];
        let avgPhValues = [];

        @foreach($phValues as $data)
        dates.push('{{ date('d-m-Y', strtotime($data['created_date'])) }}');
        maxPhValues.push({{$data['mxph']}});
        minPhValues.push({{$data['miph']}});
        avgPhValues.push({{$data['midph']}});
        @endforeach

        var chart = Highcharts.chart('containerph', {
            chart: {
                type: 'column' // Use 'column' for vertical bars
            },
            title: {
                text: 'ph Levels'
            },
            xAxis: {
                categories: dates, // Using categories for dates
                title: {
                    text: 'Date'
                }
            },
            yAxis: {
                title: {
                    text: 'ph Value'
                }
            },
            series: [{
                name: 'Max ph Val',
                data: maxPhValues,
                color: '#FF0000' // Red color for Max pH
            }, {
                name: 'Avg ph Val',
                data: avgPhValues,
                color: '#028A0F' // Green color for Avg pH
            }, {
                name: 'Min ph Val',
                data: minPhValues,
                color: '#00FF00' // Blue color for Min pH
            }]
        });

    });
    //-------------------------opr--------------------------------
    document.addEventListener('DOMContentLoaded', function() {
			// Set locale options
		Highcharts.setOptions({
			lang: {
				decimalPoint: '.',
				thousandsSep: ','
			}
		});	

        // Prepare the data for xAxis (dates) and yAxis (ph values)
        let dates = [];
        let maxPhValues = [];
        let minPhValues = [];
        let avgPhValues = [];
		
		// number_format((float)($data['midfe']), 2))
		
        @foreach($oprValues as $data)
        dates.push('{{ date('d-m-Y', strtotime($data['created_date'])) }}');
        maxPhValues.push({{number_format((float)($data['mxfe']), 2)}});
        minPhValues.push({{number_format((float)($data['mife']), 2)}});
        avgPhValues.push({{number_format((float)($data['midfe']), 2)}});
        @endforeach

        var chart = Highcharts.chart('containerOPR', {
            chart: {
                type: 'column' // Use 'column' for vertical bars
            },
            title: {
                text: 'Iron Levels'
            },
            xAxis: {
                categories: dates, // Using categories for dates
                title: {
                    text: 'Date'
                }
            },
            yAxis: {
                title: {
                    text: 'Iron Value'
                }
            },
            series: [{
                name: 'Max Iron Val',
                data: maxPhValues,
                color: '#FF0000' // Red color for Max pH
            }, {
                name: 'Avg Iron Val',
                data: avgPhValues,
                color: '#028A0F' // Green color for Avg pH
            }, {
                name: 'Min Iron Val',
                data: minPhValues,
                color: '#00FF00' // Blue color for Min pH
            }]
        });

    });
    //----------------------------chlrn-----------------------------------
    document.addEventListener('DOMContentLoaded', function() {
			// Set locale options
		Highcharts.setOptions({
			lang: {
				decimalPoint: '.',
				thousandsSep: ','
			}
		});	

        // Prepare the data for xAxis (dates) and yAxis (ph values)
        let dates = [];
        let maxPhValues = [];
        let minPhValues = [];
        let avgPhValues = [];

        @foreach($chlrnValues as $data)
        dates.push('{{ date('d-m-Y', strtotime($data['created_date'])) }}');
        maxPhValues.push({{$data['mxchlrn']}});
        minPhValues.push({{$data['michlrn']}});
        avgPhValues.push({{$data['midchlrn']}});
        @endforeach

        var chart = Highcharts.chart('containerchlrn', {
            chart: {
                type: 'column' // Use 'column' for vertical bars
            },
            title: {
                text: 'CL Levels'
            },
            xAxis: {
                categories: dates, // Using categories for dates
                title: {
                    text: 'Date'
                }
            },
            yAxis: {
                title: {
                    text: 'CL Value'
                }
            },
            series: [{
                name: 'Max CL Val',
                data: maxPhValues,
                color: '#FF0000' // Red color for Max pH
            }, {
                name: 'Avg CL Val',
                data: avgPhValues,
                color: '#028A0F' // Green color for Avg pH
            }, {
                name: 'Min CL Val',
                data: minPhValues,
                color: '#00FF00' // Blue color for Min pH
            }]
        });

    });
    //----------------------------tdsValues-----------------------------------
    document.addEventListener('DOMContentLoaded', function() {
			// Set locale options
		Highcharts.setOptions({
			lang: {
				decimalPoint: '.',
				thousandsSep: ','
			}
		});	

        // Prepare the data for xAxis (dates) and yAxis (ph values)
        let dates = [];
        let maxPhValues = [];
        let minPhValues = [];
        let avgPhValues = [];

        @foreach($tdsValues as $data)
        dates.push('{{ date('d-m-Y', strtotime($data['created_date'])) }}');
        maxPhValues.push({{$data['mxtds']}});
        minPhValues.push({{$data['mitds']}});
        avgPhValues.push({{$data['midtds']}});
        @endforeach

        var chart = Highcharts.chart('containertds', {
            chart: {
                type: 'column' // Use 'column' for vertical bars
            },
            title: {
                text: 'TDS Levels'
            },
            xAxis: {
                categories: dates, // Using categories for dates
                title: {
                    text: 'Date'
                }
            },
            yAxis: {
                title: {
                    text: 'TDS Value'
                }
            },
            series: [{
                name: 'Max TDS Val',
                data: maxPhValues,
                color: '#FF0000' // Red color for Max pH
            }, {
                name: 'Avg TDS Val',
                data: avgPhValues,
                color: '#028A0F' // Green color for Avg pH
            }, {
                name: 'Min TDS Val',
                data: minPhValues,
                color: '#00FF00' // Blue color for Min pH
            }]
        });

    });
    //----------------------------turValues-----------------------------------
    document.addEventListener('DOMContentLoaded', function() {
			// Set locale options
		Highcharts.setOptions({
			lang: {
				decimalPoint: '.',
				thousandsSep: ','
			}
		});	

        // Prepare the data for xAxis (dates) and yAxis (ph values)
        let dates = [];
        let maxPhValues = [];
        let minPhValues = [];
        let avgPhValues = [];

        @foreach($turValues as $data)
        dates.push('{{ date('d-m-Y', strtotime($data['created_date'])) }}');
        maxPhValues.push({{$data['mxtur']}});
        minPhValues.push({{$data['mitur']}});
        avgPhValues.push({{$data['midtur']}});
        @endforeach

        var chart = Highcharts.chart('containertur', {
            chart: {
                type: 'column' // Use 'column' for vertical bars
            },
            title: {
                text: 'TUR Levels'
            },
            xAxis: {
                categories: dates, // Using categories for dates
                title: {
                    text: 'Date'
                }
            },
            yAxis: {
                title: {
                    text: 'TUR Value'
                }
            },
            series: [{
                name: 'Max TUR Val',
                data: maxPhValues,
                color: '#FF0000' // Red color for Max pH
            }, {
                name: 'Avg TUR Val',
                data: avgPhValues,
                color: '#028A0F' // Green color for Avg pH
            }, {
                name: 'Min TUR Val',
                data: minPhValues,
                color: '#00FF00' // Blue color for Min pH
            }]
        });

    });
    //----------------------------turValues-----------------------------------
    document.addEventListener('DOMContentLoaded', function() {
			// Set locale options
		Highcharts.setOptions({
			lang: {
				decimalPoint: '.',
				thousandsSep: ','
			}
		});	

        // Prepare the data for xAxis (dates) and yAxis (ph values)
        let dates = [];
        let maxPhValues = [];
        let minPhValues = [];
        let avgPhValues = [];

        @foreach($water_lvlValues as $data)
        dates.push('{{ date('d-m-Y', strtotime($data['created_date'])) }}');
        maxPhValues.push({{$data['mxwater_lvl']}});
        minPhValues.push({{$data['miwater_lvl']}});
        avgPhValues.push({{$data['midwater_lvl']}});
        @endforeach

        var chart = Highcharts.chart('containerwater_lvl', {
            chart: {
                type: 'column' // Use 'column' for vertical bars
            },
            title: {
                text: 'Water Levels'
            },
            xAxis: {
                categories: dates, // Using categories for dates
                title: {
                    text: 'Date'
                }
            },
            yAxis: {
                title: {
                    text: 'Water Value'
                }
            },
            series: [{
                name: 'Max Water Val',
                data: maxPhValues,
                color: '#FF0000' // Red color for Max pH
            }, {
                name: 'Avg Water Val',
                data: avgPhValues,
                color: '#028A0F' // Green color for Avg pH
            }, {
                name: 'Min Water Val',
                data: minPhValues,
                color: '#00FF00' // Blue color for Min pH
            }]
        });

    });
</script>